/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.MarcaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import java.io.IOException;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.UiException;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.UploadEvent;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Image;
import org.zkoss.zul.Row;

/**
 * 
 * @author Administrador
 */
@Controller("editarMarcaController")
@Scope("prototype")
public class EditarMarcaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private MarcaService marcaService;
	@Autowired
	private EmpresaService empresaService;
	private Marca marca;
	private List<Empresa> lsEmpresa;
	private MyListbox marcaList;
	private BusquedaMarcaController busquedaMarcaController;
	private Image img;
	private MyTextbox txtNome;
	private Button btnApagar;
	private static Logger log = Logger.getLogger(EditarMarcaController.class);
	private Row rowEquivalencia;
	private Combobox cmbEmpresa;

	public Image getImg() {
		return img;
	}

	public void setImg(Image img) {
		this.img = img;
	}

	public Marca getMarca() {
		return marca;
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

	public void setMarca(Marca marca) {
		this.marca = marca;
	}

	public MyListbox getMarcaList() {
		return marcaList;
	}

	public void setMarcaList(MyListbox marcaList) {
		this.marcaList = marcaList;
	}

	public MyTextbox getTxtNome() {
		return txtNome;
	}

	public void setTxtNome(MyTextbox txtNome) {
		this.txtNome = txtNome;
	}

	public Button getBtnApagar() {
		return btnApagar;
	}

	public void setBtnApagar(Button btnApagar) {
		this.btnApagar = btnApagar;
	}

	public Row getRowEquivalencia() {
		return rowEquivalencia;
	}

	public void setRowEquivalencia(Row rowEquivalencia) {
		this.rowEquivalencia = rowEquivalencia;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {

		lsEmpresa = empresaService.obtenerTodos();
		super.doAfterCompose(comp);

		marca = (Marca) Executions.getCurrent().getArg().get("marca");
		busquedaMarcaController = (BusquedaMarcaController) Executions.getCurrent().getArg().get("busquedaMarcaController");
		if (marca.getLogotipomarca() != null) {
			img.setContent(new org.zkoss.image.AImage(marca.getDescmarca(),
					marca.getLogotipomarca()));
		}
		marcaList = (MyListbox) Executions.getCurrent().getArg().get("marcaList");

		if (marca.getMarcaId() == null) {
			btnApagar.setVisible(Boolean.FALSE);
		}

		if (!ApplicationProperties.getInstance().mostrarEquivalencia()) {
			rowEquivalencia.setVisible(Boolean.FALSE);
		}

		txtNome.focus();
	}

	public void uploadPhoto(UploadEvent event) {
		org.zkoss.util.media.Media media = event.getMedia();

		try {
			if (media instanceof org.zkoss.image.Image) {
				img.setContent(new org.zkoss.image.AImage(media.getName(),
						media.getStreamData()));
			} else {
				Messagebox.show(
						Labels.getLabel("editarMarcaController.MSG.errorIMG") + " " + media,
						Labels.getLabel("editarMarcaController.window.title"),
						Messagebox.OK, Messagebox.ERROR);
			}
		} catch (IOException ex) {
			log.error(ex);
			throw UiException.Aide.wrap(ex);
		} catch (InterruptedException ex) {
			log.error(ex);
			throw UiException.Aide.wrap(ex);
		}
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		txtNome.getText();
		cmbEmpresa.getValue();
		try {
			String nomeMarca = marca.getDescmarca();
			List<Marca> lsMarcas = marcaService.buscarPorNome(nomeMarca);
			boolean podeSalvar = false;
			if (lsMarcas.isEmpty()) {
				podeSalvar = true;
			} else {
				for (Marca m : lsMarcas) {
					if (m.getMarcaId().equals(marca.getMarcaId())) {
						podeSalvar = true;
					}
				}
			}

			if (podeSalvar) {
				marca.setActivo(Boolean.TRUE);
				marca.setFecmodif(Calendar.getInstance().getTime());
				marca.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

				if (img.getContent() != null) {
					marca.setLogotipomarca(img.getContent().getByteData());
				}

				if (marca.getLogotipomarca() == null) {
					int resp = Messagebox.show(
							Labels.getLabel("editarMarcaController.MSG.SinImagenPergunta"),
							Labels.getLabel("editarMarcaController.window.title"),
							Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

					if (resp == Messagebox.YES) {
						if (marca.getMarcaId() == null) {
							marcaService.suscribir(marca);
							marcaList.addItem(marca);

							Messagebox.show(
									Labels.getLabel("editarMarcaController.MSG.suscribirOK"),
									Labels.getLabel("editarMarcaController.window.title"),
									Messagebox.OK, Messagebox.INFORMATION);

							closeWindow();
						} else {
							marcaService.actualizacion(marca);
							marcaList.updateItem(marca);

							Messagebox.show(
									Labels.getLabel("editarMarcaController.MSG.suscribirOK"),
									Labels.getLabel("editarMarcaController.window.title"),
									Messagebox.OK, Messagebox.INFORMATION);

							closeWindow();
						}
					}
				} else {
					if (marca.getMarcaId() == null) {
						marcaService.suscribir(marca);
						marcaList.addItem(marca);
					} else {
						marcaService.actualizacion(marca);
						marcaList.updateItem(marca);
					}

					Messagebox.show(
							Labels.getLabel("editarMarcaController.MSG.suscribirOK"),
							Labels.getLabel("editarMarcaController.window.title"),
							Messagebox.OK, Messagebox.INFORMATION);
					busquedaMarcaController.refreshLista();
					closeWindow();
				}
			} else {
				Messagebox.show(
						Labels.getLabel("MSG.Registro.Existe"),
						Labels.getLabel("editarMarcaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			}
		} catch (Exception ex) {
			log.error("editarMarcaController: " + ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarMarcaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagar(Event ev) {
		try {
			int resp = Messagebox.show(
					Labels.getLabel("editarMarcaController.MSG.borrarPergunta"),
					Labels.getLabel("editarMarcaController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {
				marcaService.borrar(marca);

				Messagebox.show(
						Labels.getLabel("editarMarcaController.MSG.borrarOK"),
						Labels.getLabel("editarMarcaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				marcaList.removeItem(marca);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}
}
